<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00006002VariacaoTipoDeMedidaFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * A função "validaTipoMedidaVariavel" verifica se o tipo de medida variável
     * ja está criado para a faixa existente.
     */
     
    
    public function validaTipoMedidaVariavel($params){
        
        $sql = "SELECT CDTPMEDIDAVARIAVEL, QTMEDIDAINIVARIACAO, QTMEDIDAFIMVARIACAO
                  FROM FCT_VARIACAOTIPOMEDIDA
                 WHERE CDTPMEDIDASERV = :CDTPMEDIDASERV
                   AND CDTPMEDIDAVARIAVEL = :CDTPMEDIDAVARIAVEL
                   AND NRVARIACAOTPMEDIDA <> NVL(:NRVARIACAOTPMEDIDA, -1) 
                   AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
    
     /**
     * A função "validaExsiteMedidaVariavel" verifica se existem medidas variaveis 
     * para o tipo de medida atual.
     */
    
    public function validaExsiteMedidaVariavel($params){
        
        $sql = "SELECT COUNT(*) AS VALIDA
                  FROM FCT_VARIACAOTIPOMEDIDA
                 WHERE CDTPMEDIDASERV = :CDTPMEDIDASERV
                   AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
    
    /**
     * A função "validaExsiteVariacao" verifica se o tipo de medida variavel esá sendo 
     * utilizado.
     */
    
    public function validaExsiteVariacao($params){
        
        $sql = "SELECT COUNT(*) AS VALIDA
                  FROM FCT_VARIACAOTIPOMEDIDA
                 WHERE CDTPMEDIDAVARIAVEL = :CDTPMEDIDAVARIAVEL
                   AND NRORG = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        
    }
}
?>