<?php

namespace Teknisa\SM\Service;

use Teknisa\Libs\Util\ConnectionCustom;
use Doctrine\ORM\EntityManager;
use Teknisa\SM\Factory\AlertaDesalocacaoRecursoAgendadoFactory;

class AlertaDesalocacaoRecursoAgendadoService {
    
    protected $entitymanager;
    protected $connectioncustom;
    protected $alertadesalocfactory;
    
    public function __construct(ConnectionCustom $connectioncustom, EntityManager $entitymanager){
        $this->connectioncustom     = $connectioncustom;
        $this->entitymanager        = $entitymanager;
    }
    
    public function alertaDesalocacaoRecurso($nrorg){
        try {
            $dadosEmail = array();
            $entityManagerConnection = $this->connectioncustom->updateVpdConnection($nrorg);
            
            if($entityManagerConnection !== false){
                $this->entitymanager = $entityManagerConnection;
            }

            $this->alertadesalocfactory = new AlertaDesalocacaoRecursoAgendadoFactory($this->entitymanager);
            $dadosAlerta = $this->getDadosDesalocacao($nrorg)[0];
            if($dadosAlerta["DSEMAILSDESALCREC"] != null && $dadosAlerta["QTDIASDESALOCREC"] != null){
                $agendamentos = $this->getAgendamentosParaDesalocacao($dadosAlerta["QTDIASDESALOCREC"], $nrorg);
                
                if($agendamentos[0]["QTAGENDAMENTOS"] > 0){
                    $dados = array(
                        "DESTINATARIO"     => $dadosAlerta["DSEMAILSDESALCREC"],
                        "QTDIASDESALOCREC" => $dadosAlerta["QTDIASDESALOCREC"]
                    );
                    
                    array_push($dadosEmail, $dados);
                }
            }
            
            return $dadosEmail;
        } catch(\Exception $e){
            throw $e;
        }
    }

    /**
     * Busca no bd a quantidade de dias e os emails para o alerta de desalocação
    **/
    public function getDadosDesalocacao($nrorg){
        $params = array(
            "NRORG" => $nrorg
        );
        
        return $this->alertadesalocfactory->getDadosDesalocacao($params);
    }
    
    /**
     * Busca no bd a quantidade de dias e os emails para o alerta de desalocação
    **/
    public function getAgendamentosParaDesalocacao($qtDiasAlerta, $nrorg){
        $params = array(
            "QTDIASDESALOCREC" => $qtDiasAlerta,
            "NRORG"            => $nrorg
        );
        
        return $this->alertadesalocfactory->getAgendamentosParaDesalocacao($params);
    }
    
}